const qsa = (el, selectors) => el.querySelectorAll(selectors);
export class CheckPropagator {
    downCheck(el, root) {
        const currentGroupName = el.getAttribute('data-vt-groupvalue');
        if (currentGroupName) {
            const kids = Array.from(qsa(root, `[data-vt-group="${currentGroupName}"]`));
            const parentChecked = el.checked;
            for (const kid of kids) {
                kid.checked = parentChecked;
                this.downCheck(kid, root);
            }
        }
    }
    upCheck(el, root) {
        const parentGroupName = el.getAttribute('data-vt-group');
        if (parentGroupName) {
            const parentGroup = root.querySelector(`[data-vt-groupvalue="${parentGroupName}"]`);
            if (parentGroup) {
                const siblings = Array.from(qsa(root, `[data-vt-group="${parentGroupName}"]`));
                const checkedSiblings = siblings.filter((s) => s.checked);
                parentGroup.checked = siblings.length === checkedSiblings.length;
                this.upCheck(parentGroup, root);
            }
        }
    }
    propagate(valectBase, el) {
        this.downCheck(el, valectBase.root);
        this.upCheck(el, valectBase.root);
    }
}
